pro  cloud_model,  wl,  par, f, pder, amp=amp

common cloud_model_com, i_in, npar
source = sqrt(par[0]^2)
tau0=sqrt(par[1]^2)
dwl = par[2]
dwld = sqrt(par[3]^2)

if npar ge 5 then a = sqrt(par[4]^2) else a=0.
u= (wl-dwl)/dwld
if n_params() ge 4 then ch_voigt, a, u, vgt, dis, vgtda, vgtdu else $
ch_voigt, a, u, vgt, dis

ch_voigt, a, 0., vgt0
;vgt0=1.
tau = tau0*vgt/vgt0
amp = source/i_in-1.
exptau = exp(-tau)

f=amp*(1-exptau)

if n_params() ge 4 then if npar eq 5 then  $
  pder  = [ $
  [(1-exptau)/i_in*(2*(par[0] gt 0)-1)], $
  [ amp*exptau*vgt/vgt0*(2*(par[1] gt 0 )-1)], $
  [ amp*exptau*tau0*vgtdu/vgt0*(-1./dwld)], $
  [amp*exptau*tau0*vgtdu/vgt0*(-(wl-dwl)/dwld^2)*(2*(par[3] gt 0)-1)] , $
  [amp*exptau*tau0*vgtda/vgt0*(2*(par[4] gt 0)-1)] ] else $
  pder  = [ $
  [(1-exptau)/i_in*(2*(par[0] gt 0)-1)], $
  [ amp*exptau*vgt/vgt0*(2*(par[1] gt 0 )-1)], $
  [ amp*exptau*tau0*vgtdu/vgt0*(-1./dwld)], $
  [amp*exptau*tau0*vgtdu/vgt0*(-(wl-dwl)/dwld^2)*(2*(par[3] gt 0)-1)]]

end


function cloud_model_fit, wl, contrast, ref, par, sigma,  gaussian=gaussian

common cloud_model_com, i_in, npar
i_in = ref

if keyword_set(gaussian) then npar=4 else npar=5


par=fltarr(npar)
source= 0.5*min(ref)
tau0=0.5
dwl=wl[(where(contrast eq min(contrast)))[0]]
dwld=0.20
par[0]=source
par[1]=tau0
par[2]=dwl
par[3]=dwld
if npar ge 5 then par[4]=0.5
noise=stdev((contrast-shift(contrast,1))[10:n_elements(contrast)-10])
result=curvefit(wl, contrast, wl*0+.1/noise^2, par, sigma, function_name='cloud_model' )
par[[0,1,3,4]]=abs(par[[0,1,3,4]])
return, result
end